/*****************************************************
***    max7219   SPI***
******************************************************/

#define SPI_PORTX PORTB
#define SPI_DDRX DDRB

#define SPI_MISO 3
#define SPI_MOSI 2
#define SPI_SCK 1
#define SPI_SS 0

int init[]={0x0F00,0x0B07,0x0900,0x0100,0x0200,0x0300,0x0400,0x0500,0x0600,0x0700,0x0800,0x0C00}; //  
int clear[]={0x0100,0x0200,0x0300,0x0400,0x0500,0x0600,0x0700,0x0800};                            //  
int setup[] = {0x0C01,0x0A08,0x0100,0x0200,0x0300,0x0400,0x0500,0x0600,0x0700,0x0800};            //   (,  )


// max7219


unsigned char cascade = 4;    //  ( )


/* SPI    master*/
void spi_init(void)
{
   /*  -
    ,  MISO */
   SPI_DDRX |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS)|(0<<SPI_MISO);
   SPI_PORTX |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS)|(0<<SPI_MISO);

   /* spi,  ,,  0*/
   SPCR = (1<<SPE)|(0<<DORD)|(1<<MSTR)|(0<<CPOL)|(0<<CPHA)|(1<<SPR0)|(0<<SPR0); //  SPR1  SPR0   
   SPSR = (0<<SPI2X); }                                                         //   spi


void spi_write_word(unsigned int data)   //    (  )   MOSI
{                                        //         

   SPDR = (data>>8);
   while(!(SPSR & (1<<SPIF)));
    SPDR = data;
   while(!(SPSR & (1<<SPIF)));

}


void matrix_setup (void){
unsigned char i;               //      .
                               //   ,     0000 (00-0F  0-15)
 if(cascade==4){
   for(i=0;i<10;i++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0xf000);
   spi_write_word(0xf000);
   spi_write_word(0xf000);
   spi_write_word(setup[i]);
   SPI_PORTX |= (1<<SPI_SS);};

   for(i=0;i<10;i++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(setup[i]);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);};

   for(i=0;i<10;i++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(setup[i]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);};

   for(i=0;i<10;i++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(setup[i]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);};
   };
   if(cascade==3){
     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(0x0000);
     spi_write_word(0x0000);
     spi_write_word(setup[i]);
     SPI_PORTX |= (1<<SPI_SS);};

     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(0xf000);
     spi_write_word(setup[i]);
     spi_write_word(0xf000);
     SPI_PORTX |= (1<<SPI_SS);};

     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(setup[i]);
     spi_write_word(0xf000);
     spi_write_word(0xf000);
     SPI_PORTX |= (1<<SPI_SS);};
     };
     if(cascade==2){
     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(0xf000);
     spi_write_word(setup[i]);
     SPI_PORTX |= (1<<SPI_SS);};

     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(setup[i]);
     spi_write_word(0xf000);
     SPI_PORTX |= (1<<SPI_SS);};
     };

     if(cascade==1){
     for(i=0;i<10;i++){
     SPI_PORTX &= ~(1<<SPI_SS);
     spi_write_word(setup[i]);
     SPI_PORTX |= (1<<SPI_SS);};
     };
 }




void matrix_clear(void){        // 
 unsigned char n;

 if(cascade==4){
   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };
  }
 if(cascade==3){
   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   SPI_PORTX |= (1<<SPI_SS);;
   };
  };

  if(cascade==2){
   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(clear[n]);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);;
   };

   for (n=0;n<8;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(clear[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };
  };

  if(cascade==1){
  SPI_PORTX &= ~(1<<SPI_SS);
   for (n=0;n<8;n++){
   spi_write_word(clear[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };
  };
}

void matrix_init(void) {         //  :   0F,09,0C

 unsigned char n;

 if(cascade==4){

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(init[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(init[n]);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0x0000);
   spi_write_word(init[n]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(init[n]);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   spi_write_word(0x0000);
   SPI_PORTX |= (1<<SPI_SS);
   };
  }
 if(cascade==3){
   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0xf000);
   spi_write_word(0xf000);
   spi_write_word(init[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0xf000);
   spi_write_word(init[n]);
   spi_write_word(0xf000);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(init[n]);
   spi_write_word(0xf000);
   spi_write_word(0xf000);
   SPI_PORTX |= (1<<SPI_SS);
   };
  };

  if(cascade==2){
   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(0xf000);
   spi_write_word(init[n]);
   SPI_PORTX |= (1<<SPI_SS);
   };

   for (n=0;n<12;n++){
   SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(init[n]);
   spi_write_word(0xf000);
   SPI_PORTX |= (1<<SPI_SS);
    };
  };

  if(cascade==1){
  for (n=0;n<12;n++){
  SPI_PORTX &= ~(1<<SPI_SS);
   spi_write_word(init[n]);
   SPI_PORTX |= (1<<SPI_SS);
    };
  };
}

void matrix_set_col(int column, char data){     //     32 (1-32)
                                                // -     
 if(cascade==4){
   if(column<=8){
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};

   if(column>8){if(column<=16){
               column=column-8;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};};

   if(column>16){if(column<=24){
               column=column-16;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};};

   if(column>24){if(column<=32){
               column=column-24;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               SPI_PORTX |= (1<<SPI_SS);};};
   };
 if(cascade==3){
    if(column<=8){
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};

    if(column>8){if(column<=16){
               column=column-8;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};};

    if(column>16){if(column<=24){
               column=column-16;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               SPI_PORTX |= (1<<SPI_SS);};};
   };
 if(cascade==2){
    if(column<=8){
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word((column<<8)|data);
               spi_write_word(0x0000);
               SPI_PORTX |= (1<<SPI_SS);};

    if(column>8){if(column<=16){
               column=column-8;
               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word(0x0000);
               spi_write_word((column<<8)|data);
               SPI_PORTX |= (1<<SPI_SS);};};
    };
   if(cascade==1){

               SPI_PORTX &= ~(1<<SPI_SS);
               spi_write_word((column<<8)|data);
               SPI_PORTX |= (1<<SPI_SS);};

}

void write_symbol(char column, char bookva[]){
  char i;
  for(i=0;i<5;i++){

  matrix_set_col(column, bookva[i]);
  column++;
    };
  }

